/* 
 * PDFlib PLOP: 
 * Demonstrate mass signature features with optional PKCS#11 session handling
 */

import java.io.*;
import com.pdflib.plop;
import com.pdflib.PLOPException;

public class multisign
{
    public static void main (String argv[])
    {
        plop plop = null;

        /* Basic signature options */
        String sign_opts =
            "ltv=try " +         /* use ltv=full to ensure LTV status */
            /* for the ustage with PKCS11
            "engine=pkcs#11 digitalid={filename=cryptoki.dll} "
            */
            "engine=builtin digitalid={filename=demo_signer_rsa_2048.p12} password={demo} ";
        boolean PKCS11 = false;
        
        try {
            /* parameters for the input document */
            String optlist;
            String signed_name = "";
            String searchpath = "../data";

            int doc;
            int i;

            if (argv.length <  1)
            {
                throw new Exception("usage: sign  <infile> ...");
            }

            plop = new plop();

            /* open unprotected input file without any password */
            optlist = "searchpath {" + searchpath + "} ";
            plop.set_option(optlist);

            if (plop.prepare_signature(sign_opts) == -1) {
                throw new Exception("Error: " + plop.get_apiname()
                                        + ": " + plop.get_errmsg());
            }
            for (i = 0; i < argv.length; i++){

                System.out.println("Signing '" + argv[i] + "'");

                if ((doc = plop.open_document(argv[i], "")) == -1) {
                    System.err.println("Error: " + plop.get_apiname()
                                            + ": " + plop.get_errmsg());
                    continue;
                }
                signed_name = argv[i] + "-signed.pdf"; 

                if (plop.create_document(signed_name, "input=" + doc) == -1) {
                    System.err.println("Error: " + plop.get_apiname()
                                            + ": " + plop.get_errmsg());
                    if (PKCS11){
                        if (plop.prepare_signature(optlist) == -1) {
                            throw new Exception("Error: " + plop.get_apiname()
                                                    + ": " + plop.get_errmsg());
                        }

                        if (plop.create_document(signed_name, "input=" + doc) == -1) {
                            throw new Exception("Error: " + plop.get_apiname()
                                                    + ": " + plop.get_errmsg());
                        }
                    }
                }

                /* close output file */
                plop.close_document(doc, "");
            }

        } catch (PLOPException e) {
            System.err.println("PLOP exception occurred in multisign sample:");
            System.err.println("[" + e.get_errnum() + "] " + e.get_apiname() +
                            ": " + e.get_errmsg());
        } catch (Exception e) {
            System.err.println(e);
        } finally {
            /* delete the PLOP object */
            if (plop != null) plop.delete();
        }
    }
}
